package org.nuiton.topiatest;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.nuiton.topia.TopiaException;
import org.nuiton.topia.TopiaTestDAOHelper.TopiaTestEntityEnum;
import org.nuiton.topia.persistence.TopiaDAOImpl;
import org.nuiton.topia.persistence.TopiaEntity;

public abstract class BillDAOAbstract<E extends Bill> extends TopiaDAOImpl<E> {

    @Override
    public Class<E> getEntityClass() {
        return (Class<E>)Bill.class;
    }

    @Override
    public TopiaTestEntityEnum getTopiaEntityEnum() {
        return TopiaTestEntityEnum.Bill;
    }

    public E findByCost(int v) throws TopiaException {
        E result = findByProperty(Bill.PROPERTY_COST, v);
        return result;
    }

    public List<E> findAllByCost(int v) throws TopiaException {
        List<E> result = findAllByProperty(Bill.PROPERTY_COST, v);
        return result;
    }

    public E findByDate(Date v) throws TopiaException {
        E result = findByProperty(Bill.PROPERTY_DATE, v);
        return result;
    }

    public List<E> findAllByDate(Date v) throws TopiaException {
        List<E> result = findAllByProperty(Bill.PROPERTY_DATE, v);
        return result;
    }

    public E findByPaid(Boolean v) throws TopiaException {
        E result = findByProperty(Bill.PROPERTY_PAID, v);
        return result;
    }

    public List<E> findAllByPaid(Boolean v) throws TopiaException {
        List<E> result = findAllByProperty(Bill.PROPERTY_PAID, v);
        return result;
    }

    @Override
    public <U extends TopiaEntity> List<U> findUsages(Class<U> type, E entity) throws TopiaException {
        return new ArrayList<U>();
    }

    @Override
    public Map<Class<? extends TopiaEntity>, List<? extends TopiaEntity>> findAllUsages(E entity) throws TopiaException {
        return new HashMap<Class<? extends TopiaEntity>, List<? extends TopiaEntity>>();
    }

} //BillDAOAbstract<E extends Bill>
